/* eggdrop module to handle msg, notice, channel msg, channel notice, and
   elementary ctcp and ctcp-replies. */

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <varargs.h>
#include "eggdrop.h"

#define FINGER "is an EGGDROP bot, idle 0 seconds always."
#define SOURCE "email rpointe@eng.clemson.edu"
#define CLIENTINFO "FINGER PING ECHO ERRMSG VERSION SOURCE USERINFO CLIENTINFO DCC"

/* used as a parameter to detect_flood */
#define _NICK     1
#define _PRIVMSG  2
#define _NOTICE   3
#define _CTCP     4

/* whether or not to display the time with console output */
int shtime=0;
/* whether or not to do console output at all */
int use_console=1;
/* if true, display to console all msgs & publics */
int spymode=0;
/* if true, show public spies too */
int spypub=0;

extern int serv;
extern int memused;
extern int backgrd;
extern int con_chan;
extern int term_z;
extern char botname[];
extern char helpbot[];
extern char version[];
extern char curchan[];
extern char logfile[];
extern struct dcc_t dcc[MAXDCC];
extern int dcc_total;
extern char admin[];

void console(va_alist)
va_dcl
{
  int i; char s1[41],s[512],s2[512]; char *format; va_list va; time_t tt;
  FILE *f;
  if (!use_console) return;
  va_start(va); format=va_arg(va,char *);
  vsprintf(s,format,va);
  if (s[0]==0) strcpy(s,"\n");
  else if (shtime) {
    tt=time(NULL); strcpy(s1,ctime(&tt));
    strcpy(s1,&s1[11]); s1[5]=0;
    sprintf(s2,"[%s] %s\n",s1,s); strcpy(s,s2);
  }
  else strcat(s,"\n");
  if ((backgrd) || (con_chan) || (term_z)) {
    f=fopen(logfile,"a+"); if (f!=NULL) {
      fprintf(f,"%s",s); fclose(f);
    }
  }
  else printf("%s",s);
  for (i=0; i<dcc_total; i++) 
    if ((dcc[i].type==DCC_CHAT) && (dcc[i].status&STAT_CONSOLE)) {
      if (dcc[i].status&STAT_CR) tprintf(dcc[i].sock,"%s\r",s);
      else tprintf(dcc[i].sock,"%s",s);
    }
  va_end(va);
}

/* ctcp embedded in a privmsg */
void gotctcp(ffrom,to,msg)
char *ffrom,*to,*msg;
{
  char from[81],nick[10],code[512]; char *p;
  strcpy(from,ffrom);
  split(code,msg); splitnick(nick,from);
  if (code[0]==0) { strcpy(code,msg); msg[0]=0; }
  /* unquote if necessary */
  p=strchr(msg,'\\');
  while (p!=NULL) {
    if (*(p+1)=='a') *(p+1)=1;
    strcpy(p,p+1);
    p=strchr(msg,'\\');
  }
  if (strcmp(code,"FINGER")==0)
    mprintf(serv,"NOTICE %s :%cFINGER %s %s%c\n",nick,1,botname,FINGER,1);
  else if ((strcmp(code,"PING")==0) || (strcmp(code,"ECHO")==0) ||
	   (strcmp(code,"ERRMSG")==0))
    mprintf(serv,"NOTICE %s :%c%s %s%c\n",nick,1,code,msg,1);
  else if (strcmp(code,"VERSION")==0)
    mprintf(serv,"NOTICE %s :%cVERSION %s using %s%c\n",nick,1,botname,version,
	    1);
  else if (strcmp(code,"SOURCE")==0)
    mprintf(serv,"NOTICE %s :%cSOURCE %s%c\n",nick,1,SOURCE,1);
  else if (strcmp(code,"USERINFO")==0)
    mprintf(serv,"NOTICE %s :%cUSERINFO %s%c\n",nick,1,admin,1);
  else if (strcmp(code,"CLIENTINFO")==0)
    mprintf(serv,"NOTICE %s :%cCLIENTINFO %s%c\n",nick,1,CLIENTINFO,1);
  else if (strcmp(code,"DCC")==0)
    gotdcc(nick,from,msg);
  else if (strcmp(code,"ACTION")==0)
    ;  /* ignore */
  else
    ;  /* ignore */
  if ((spymode) && (strcmp(code,"DCC")!=0)) {
    if ((to[0]=='#') || (to[0]=='&')) {
      if (spypub) {
	if (strcmp(code,"ACTION")==0)
	  console("Action: %s %s",nick,msg);
	else
	  console("CTCP %s: %s from %s (%s) to %s",code,msg,nick,from,to);
      }
    }
    else {
      if (strcmp(code,"ACTION")==0)
	console("Action to %s: %s %s",to,nick,msg);
      else
	console("CTCP %s: %s from %s (%s)",code,msg,nick,from);
    }
  }
}

/* ctcp embedded in a notice */
void gotctcpreply(ffrom,to,msg)
char *ffrom,*to,*msg;
{
  char from[81],nick[10],code[512]; char *p;
  strcpy(from,ffrom);
  split(code,msg); splitnick(nick,from);
  if (code[0]==0) { strcpy(code,msg); msg[0]=0; }
  /* unquote if necessary */
  p=strchr(msg,'\\');
  while (p!=NULL) {
    if (*(p+1)=='a') *(p+1)=1;
    strcpy(p,p+1);
    p=strchr(msg,'\\');
  }
  /* who cares? */
  if (spymode)
    console("CTCP reply %s: %s from %s (%s) to %s",code,msg,nick,from,to);
}  

/* public msg on channel */
void gotpublic(from,to,msg)
char *from,*to,*msg;
{
  char nick[10];
  detect_flood(from,_PRIVMSG,1);
  splitnick(nick,from);
  if ((spymode) && (spypub)) {
    if (strcasecmp(curchan,to)==0)
      console("<%s> %s",nick,msg);
    else
      console("<%s:%s> %s",nick,to,msg);
  }
}

/* public notice on channel */
void gotpublicnotice(from,to,msg)
char *from,*to,*msg;
{
  char nick[10];
  detect_flood(from,_NOTICE,1);
  splitnick(nick,from);
  if ((spymode) && (spypub)) console("-%s:%s- %s",nick,to,msg);
}

/* private message */
void gotmsg(from,msg)
char *from,*msg;
{
  char to[81],nick[10],ctcp[512]; char *p,*p1;
  split(to,msg); fixcolon(msg);
  /* check for CTCP: */
  p=strchr(msg,1);
  while (p!=NULL) {
    p++; p1=p;
    while ((*p != 1) && (*p != 0)) p++;
    if (*p==1) { *p=0; strcpy(ctcp,p1); strcpy(p1-1,p+1); }
    else { strcpy(ctcp,p1); strcpy(p1-1,p); }
    detect_flood(from,_CTCP,0);
    gotctcp(from,to,ctcp);
    p=strchr(msg,1);
  }
  if (msg[0]==0) return;  /* oh. no msg. well forget it then! */
  if ((to[0]=='#') || (to[0]=='&')) {   /* it's a public msg */
    gotpublic(from,to,msg);
  } 
  else {
    detect_flood(from,_PRIVMSG,0);
    splitnick(nick,from);
    gotcmd(nick,from,msg);
  } 
}

/* private notice */
void gotnotice(from,msg)
char *from,*msg;
{
  char to[81],nick[10],ctcp[512]; char *p,*p1;
  split(to,msg); fixcolon(msg);  
  /* check for CTCP: */
  p=strchr(msg,1);
  while (p!=NULL) {
    p++; p1=p;
    while ((*p != 1) && (*p != 0)) p++;
    if (*p==1) { *p=0; strcpy(ctcp,p1); strcpy(p1-1,p+1); }
    else { strcpy(ctcp,p1); strcpy(p1-1,p); }
    detect_flood(from,_CTCP,0);
    gotctcpreply(from,to,ctcp);
    p=strchr(msg,1);
  }
  if (msg[0]==0) return;  /* oh. no msg. well forget it then! */
  if ((to[0]=='#') || (to[0]=='&')) {   /* it's a public msg */
    gotpublicnotice(from,to,msg);
  } 
  else {
    detect_flood(from,_NOTICE,0);
    if (spymode) {
      /* server notice? */
      if (from[0]==0) {
	console("-NOTICE- %s",msg);
      }
      else {
	splitnick(nick,from);
	console("-%s (%s)- %s",nick,from,msg);
      }
    }
  }
}
